"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tokenizer_1 = require("../../sucrase-babylon/tokenizer");
const JSXTransformer_1 = require("../transformers/JSXTransformer");
function getNonTypeIdentifiers(tokens) {
    const nonTypeIdentifiers = new Set();
    for (let i = 0; i < tokens.tokens.length; i++) {
        const token = tokens.tokens[i];
        if (token.type === 2048 /* name */ &&
            !token.isType &&
            (token.identifierRole === tokenizer_1.IdentifierRole.Access ||
                token.identifierRole === tokenizer_1.IdentifierRole.ObjectShorthand ||
                token.identifierRole === tokenizer_1.IdentifierRole.ExportAccess)) {
            nonTypeIdentifiers.add(tokens.identifierNameForToken(token));
        }
        if (token.type === 26112 /* jsxName */ && token.identifierRole === tokenizer_1.IdentifierRole.Access) {
            nonTypeIdentifiers.add("React");
            const identifierName = tokens.identifierNameForToken(token);
            // Lower-case single-component tag names like "div" don't count.
            if (!JSXTransformer_1.startsWithLowerCase(identifierName) || tokens.tokens[i + 1].type === 9216 /* dot */) {
                nonTypeIdentifiers.add(tokens.identifierNameForToken(token));
            }
        }
    }
    return nonTypeIdentifiers;
}
exports.getNonTypeIdentifiers = getNonTypeIdentifiers;
