import { IdentifierRole } from "../../sucrase-babylon/tokenizer";
import { startsWithLowerCase } from "../transformers/JSXTransformer";
export function getNonTypeIdentifiers(tokens) {
    const nonTypeIdentifiers = new Set();
    for (let i = 0; i < tokens.tokens.length; i++) {
        const token = tokens.tokens[i];
        if (token.type === 2048 /* name */ &&
            !token.isType &&
            (token.identifierRole === IdentifierRole.Access ||
                token.identifierRole === IdentifierRole.ObjectShorthand ||
                token.identifierRole === IdentifierRole.ExportAccess)) {
            nonTypeIdentifiers.add(tokens.identifierNameForToken(token));
        }
        if (token.type === 26112 /* jsxName */ && token.identifierRole === IdentifierRole.Access) {
            nonTypeIdentifiers.add("React");
            const identifierName = tokens.identifierNameForToken(token);
            // Lower-case single-component tag names like "div" don't count.
            if (!startsWithLowerCase(identifierName) || tokens.tokens[i + 1].type === 9216 /* dot */) {
                nonTypeIdentifiers.add(tokens.identifierNameForToken(token));
            }
        }
    }
    return nonTypeIdentifiers;
}
